<?php

# GET /getordersinprocessing
	
	
	class getordersinprocessing extends WC_API_Resource {
		
		protected $base = '/getordersinprocessing';
		
		
		public function register_routes( $routes ) {
			
			$routes[ $this->base ] = [
				
				[ [ $this, 'get' ], WC_API_Server::READABLE | WC_API_Server::EDITABLE | WC_API_Server::ACCEPT_DATA ],
			
			];
			
			return $routes;
			
		}
		
		
		public function get() {
			
			try {
				
				global $wpdb;
				
				
				$tableprefix = $wpdb->prefix;
				
				
				$sql = "SELECT p.ID as order_number, pm.meta_value as order_internalid from "
				
				       . $tableprefix . "posts p JOIN " . $tableprefix . "postmeta pm ON "
				
				       . "pm.post_id = p.ID WHERE p.post_type='shop_order' and p.post_status='wc-processing' "
				
				       . "and pm.meta_key='internalid' AND pm.meta_value REGEXP '[0-9]+'";
				
				
				$result = $wpdb->get_results( $sql );
				
				$orderpointers = [];
				
				
				foreach ( $result as $row ) {
					
					$order_number = $row->order_number;
					
					$order_internalid = $row->order_internalid;
					
					
					$order_type = metadata_exists( 'post', $order_number, 'order_type' ) ? get_post_meta( $order_number, 'order_type', TRUE ) : "sales_order";
					
					
					$pointer = new StdClass();
					
					$pointer->OrderNumber = $order_number;
					
					$pointer->OrderType = $order_type;
					
					$pointer->InternalId = $order_internalid;
					
					$pointer->OrderMeta = NULL;
					
					$pointer->Order = NULL;
					
					
					$orderpointers[] = $pointer;
					
				}
				
				
				return [ "pointers" => $orderpointers ];
				
			} catch ( WC_API_Exception $e ) {
				
				return new WP_Error( $e->getErrorCode(), $e->getMessage(), [ 'status' => $e->getCode() ] );
				
			}
			
		}
		
	}
	