<?php

# GET /getordersnew
	
	
	class getordersnew extends WC_API_Orders {
		
		protected $base = '/getordersnew';
		
		
		public function register_routes( $routes ) {
			
			$routes[ $this->base ] = [
				
				[ [ $this, 'get' ], WC_API_Server::READABLE | WC_API_Server::EDITABLE | WC_API_Server::ACCEPT_DATA ],
			
			];
			
			return $routes;
			
		}
		
		
		public function get() {
			
			try {
				
				global $wpdb;
				
				
				$tableprefix = $wpdb->prefix;
				
				
				$sql = "SELECT p.ID as order_number from " . $tableprefix . "posts p WHERE p.post_type='shop_order' "
				
				       . "AND p.post_status='wc-processing' AND NOT EXISTS(SELECT * FROM " . $tableprefix . "postmeta pm "
				
				       . "WHERE pm.post_id = p.ID and pm.meta_key='internalid' AND pm.meta_value REGEXP '[0-9]+')";
				
				
				$result = $wpdb->get_results( $sql );
				
				
				$orderpointers = [];
				
				$filter['page'] = 1;
				
				$filter['meta'] = "true";
				
				
				foreach ( $result as $row ) {
					
					$order_number = $row->order_number;
					
					
					$order = $this->get_order( $order_number, NULL, $filter );
					
					$order_type = metadata_exists( 'post', $order_number, 'order_type' ) ? get_post_meta( $order_number, 'order_type', TRUE ) : "sales_order";
					
					$meta_object = get_post_meta( $order_number );
					
					
					$meta_array = [];
					
					
					foreach ( $meta_object as $key => $value ) {
						
						
						$meta = new StdClass();
						
						$meta->Key = $key;
						
						$meta->Value = $value[0];
						
						
						array_push( $meta_array, $meta );
						
					}
					
					
					$pointer = new StdClass();
					
					$pointer->OrderNumber = $order_number;
					
					$pointer->OrderType = $order_type;
					
					$pointer->Order = $order["order"];
					
					$pointer->OrderMeta = $meta_array;
					
					$pointer->InternalId = NULL;
					
					
					$orderpointers[] = $pointer;
					
				}
				
				
				return [ "pointers" => $orderpointers ];
				
			} catch ( WC_API_Exception $e ) {
				
				return new WP_Error( $e->getErrorCode(), $e->getMessage(), [ 'status' => $e->getCode() ] );
				
			}
			
		}
		
	}
	