<?php
	
	class in8_giftcertificate extends WC_API_Resource {
		
		
		protected $base = '/in8_giftcertificate';
		public function register_routes( $sroutes ) {
			
			# GET /Update Order Item details and recalculate.
			
			$sroutes[ $this->base ] = [
				[ [ $this, 'giftcertificates' ], WC_API_Server::READABLE | WC_API_Server::EDITABLE | WC_API_Server::ACCEPT_DATA ],
			];
			
			return $sroutes;
		}
		
		public function giftcertificates() {
			
			error_reporting(-1);
			// They are looking up data
			
			if( !empty($_REQUEST['search']) ){
				return $this->search();
			}
			
			$data = $_REQUEST['data'];
			$certificate = json_decode( base64_decode( $data ), TRUE );
			
			if( empty($certificate) ){
				echo json_encode( [ "success" => false, "errors" => "You're not sending the gift certificate data" ] );
				exit;
			}
			
			
			$result = [];
			
			$args = wp_parse_args($certificate, [
				'number'              => null,
				'voucher_id'          => 0, // i can use internalid to search if you can't save the wc id on ns
				
				// extra fields, not sure if required
				'voucher_template_id' => 0,
				'voucher_image_id'    => 0,
				'voucher_type'        => null,
				'currency'            => null,
				'user_id'             => 0,
				'order_id'            => 0,
				'product_id'          => 0,
				'product_price'       => null,
				'product_tax'         => null,
				'product_quantity'    => 1,
				'order_item_id'       => 0,
				'date'                => null // date in UTC
			]);
			
			// search for existing giftcert
//			$args['voucher_id'] = (int) id;
			
			$voucher = wc_pdf_product_vouchers_create_voucher($args);
			
			$result['voucher'] = $voucher;
			
			if( isset($certificate['remaining_value']) ) {
				update_post_meta( $voucher->get_id(), '_remaining_value', $certificate['remaining_value'] );
			}
			
			// set voucher to active
			wp_update_post(array(
				'ID'    =>  $voucher->get_id(),
				'post_status'   =>  'wcpdf-active'
			));
			
			
			echo json_encode( [ "success" => "Gift certificate created", "result" => $result  ] );
			exit;
		}
		
		public function search(){
			$search = $_REQUEST['search'];
			
			$args = [
				'post_type' => 'wcpdf_voucher',
				'post_status' => 'any',
				'posts_per_page' => -1,
				'meta_query' => [
					'relation' => 'OR',
					[
						'key' => '_voucher_number',
						'value' => $search,
						'compare' => 'LIKE'
					],
					[
						'key' => '_voucher_id',
						'value' => $search,
						'compare' => 'LIKE'
					],
				]
			];
			
			$posts = get_posts($args);
			
			echo json_encode( [ "result" => $posts  ] );
			exit;
		}
		
	}
