<?php

    class In8_NetSuite_Contacts {

        public function __construct() {
            add_action("wp_ajax_in8_contact_save_form", [$this, 'saveContact']);
        }

        function saveContact() {
            $current_user = get_current_user_id();

            $current_user_ns_internal_id = get_user_meta($current_user, 'customerinternalid', TRUE);

            $return['status'] = 0;

            if ($current_user && !empty($current_user) && $current_user_ns_internal_id) {
                $data = $_REQUEST['data'];
                if (!empty($data)) {
                    $params = [];
                    parse_str($data, $params);
                    if (!empty($params['ns_contact']) && !empty($params['ns_contact']['firstname']) && $params['ns_contact']['lastname'] && $params['ns_contact']['email']) {


                        if (!class_exists('NetsuiteConnection')) {
//netsuite api connection file
                            require_once(WP_PLUGIN_DIR . '/in8sync/code/netsuiteconnection.php');
                        }

                        $record_type = 'contact';

                        $netsuite_connection = new NetsuiteConnection($current_user, $record_type);

                        $contact_data = [
                            'recordType' => $record_type,
                            'company' => $current_user_ns_internal_id,
                            'firstname' => $params['ns_contact']['firstname'],
                            'lastname' => $params['ns_contact']['lastname'],
                            'email' => $params['ns_contact']['email']
                        ];

                        $contact_response = $netsuite_connection->doRequest($contact_data);
                        if ($contact_response && isset($contact_response['data']['id'])) {
                            $return['status'] = 1;
                            $return['internalid'] = $contact_response['data']['id'];
                            $return['text'] = $params['ns_contact']['firstname'] . " " . $params['ns_contact']['lastname'];

                            $NS_contacts = get_user_meta($current_user, 'contacts', TRUE);
                            $params['ns_contact']['internalid'] = $contact_response['data']['id'];

                            if (!empty($NS_contacts)) {
                                $NS_contacts = array_values($NS_contacts + $params);
                            } else {
                                $NS_contacts = array_values($params);
                            }

                            update_user_meta($current_user, 'contacts', $NS_contacts);
                        } else {
                            $return['message'] = "Failed to create contact.Please contact site administration.";
                        }
                    } else {
                        $return['message'] = "Firstname, lastname and email should not be empty";
                    }
                } else {
                    $return['message'] = "Request data seems to be invalid";
                }
            } else {
                $return['message'] = "You must be logged in order to add a new contact";
            }

            echo json_encode($return);
            exit();
        }

    }

    new In8_NetSuite_Contacts();
    